> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/private-cloud-director/2025.4/reference/openstack-cli.md).

# Openstack CLI

Platform9's <code class="expression">space.vars.product\_name</code> is built behind the scenes using KVM, OpenStack and Kubernetes. All <code class="expression">space.vars.product\_acronym</code> core services expose OpenStack APIs and as such you can use the Openstack CLI to perform an even wider set of operations than what you can do using the <code class="expression">space.vars.product\_name</code> UI.

This guide provides steps to install and configure the Openstack CLI.

### Install OpenStack CLI

Run this command to install OpenStack CLI on your local machine.

{% tabs %}
{% tab title="Bash" %}

```bash
apt install python3-openstackclient -y
```

{% endtab %}
{% endtabs %}

### Authenticate OpenStack CLI

The <code class="expression">space.vars.product\_name</code> UI provides you with OpenStack RC file that's configured specific to your <code class="expression">space.vars.product\_name</code> environment, to be used with the OpenStack CLI.

1. Navigate to `Access & Security -> API Access -> OpenStack RC` in UI
2. Copy the contents to a new file named `openstackrc` and update `OS_PASSWORD` with your <code class="expression">space.vars.product\_name</code> password.
3. Run `source openstackrc` to set the environment variables.

### Run OpenStack CLI

Now you are ready to run the OpenStack CLI. The following command will list all virtual machines in your current tenant.

{% tabs %}
{% tab title="Bash" %}

```bash
openstack server list
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.platform9.com/private-cloud-director/2025.4/reference/openstack-cli.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
